﻿using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.GridHelperClasses;
using Syncfusion.Grouping;

namespace CellGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataCollection data = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            data.Add(new Data(1, "Thomas Hardy", "Male", DateTime.Now.AddDays(1)));
            data.Add(new Data(2, "Christiana", "Female", DateTime.Now.AddDays(2)));
            data.Add(new Data(3, "Laurance", "Male", DateTime.Now.AddDays(2)));
            data.Add(new Data(4, "Victoria", "Female", DateTime.Now.AddDays(4)));
            data.Add(new Data(5, "Stefen", "Male", DateTime.Now.AddDays(5)));
            data.Add(new Data(6, "Annie", "Female", DateTime.Now.AddDays(6)));
            data.Add(new Data(1, "Thomas Hardy", "Male", DateTime.Now.AddDays(1)));
            data.Add(new Data(2, "Christiana", "Female", DateTime.Now.AddDays(2)));
            data.Add(new Data(3, "Laurance", "Male", DateTime.Now.AddDays(2)));
            data.Add(new Data(4, "Victoria", "Female", DateTime.Now.AddDays(4)));
            data.Add(new Data(5, "Stefen", "Male", DateTime.Now.AddDays(5)));
            data.Add(new Data(6, "Annie", "Female", DateTime.Now.AddDays(6)));

            gridGroupingControl1.DataSource = data;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;

            this.gridGroupingControl1.TableDescriptor.Columns["HiredDate"].Appearance.AnyRecordFieldCell.Format = "MM/dd/yyyy";

            this.gridGroupingControl1.TableControlDrawCellDisplayText += new GridTableControlDrawCellDisplayTextEventHandler(gridGroupingControl1_TableControlDrawCellDisplayText);

            //Event Subscription.
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

        }

        void gridGroupingControl1_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        {
            GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;
            if (style != null && style.TableCellIdentity != null && style.TableCellIdentity.DisplayElement != null
                && style.TableCellIdentity.DisplayElement.GetRecord() != null && style.TableCellIdentity.Column != null)
            {
                Record record = style.TableCellIdentity.DisplayElement.GetRecord();
                string value = record["Gender"].ToString();
                if (record.IsSelected())
                {
                    if (value == "Male" && style.TableCellIdentity.Column.Name == "Name")
                    {
                        e.Inner.Graphics.FillRectangle(new SolidBrush(Color.Blue), e.Inner.TextRectangle);
                    }
                    else if (style.TableCellIdentity.Column.Name == "Name")
                    {
                        e.Inner.Graphics.FillRectangle(new SolidBrush(Color.Pink), e.Inner.TextRectangle);
                    }
                }
            }
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            GridTableCellStyleInfo style = e.Style as GridTableCellStyleInfo;
            if (style != null && style.TableCellIdentity != null && style.TableCellIdentity.DisplayElement != null
                && style.TableCellIdentity.DisplayElement.GetRecord() != null && style.TableCellIdentity.Column != null)
            {
                Record record = style.TableCellIdentity.DisplayElement.GetRecord();
                string value = record["Gender"].ToString();
                if (value == "Male" && style.TableCellIdentity.Column.Name == "Name")
                {
                    style.BackColor = Color.Blue;
                    style.TextColor = Color.White;
                }
                else if (style.TableCellIdentity.Column.Name == "Name")
                {
                    style.BackColor = Color.Pink;
                    style.TextColor = Color.White;
                }
            }
        }
    }
}
